math::TLibrary< class > Class Template Reference

`#include <library.h>`

Inheritance diagram for math::TLibrary< class >:
[legend]

## Public Member Functions

| TLibrary (const TLibrary< T > &)
void | insert (const TFunction< T > &, bool AReplaceIfExists=false)
| inserts given function into library, it throws if it's duplicated
void | insert (const TConstant< T > &, bool AReplaceIfExists=false)
| inserts given constant into library, it throws if it's duplicated
void | remove (const std::string &AName)
| removes function or constant called AName
TFunction< T > | function (const std::string &AName) const
| returns reference to requested function, throws if not found
TConstant< T > | constant (const std::string &AName) const
| returns reference to requested constant, throws if not fuond
bool | hasFunction (const std::string &AName) const
| returns true, if function (AName) exists
bool | hasConstant (const std::string &AName) const
| returns true, if constant (AName) exists
T | call (const std::string &AName, const T &AParam) const
| call() looks for a function AName calls it using AParam and returns its result. It throws on lookup error.
T | value (const std::string &AName) const
| value() look for a constant AName and returns its value. It throws on lookup error.
unsigned | functions () const
| returns the number of functions stored in this library.
unsigned | constants () const
| returns the number of constants stored in this library.

## Detailed Description

### template<class>
class math::TLibrary< class >

TLibrary<> is used to manage multiple functions and constants to be shared and to be called each other. Note, that you can't have a function called f and a constant called f.

Definition at line 35 of file calculator.h.

The documentation for this class was generated from the following files:

- calculator.h
- library.h